nmero	EQU	2	; ndice em bytes (dentro da ficha) do campo nmero
extenso	EQU	4	; ndice em bytes (dentro da ficha) do campo extenso
idade		EQU	6	; ndice em bytes (dentro da ficha) do campo idade
salrio	EQU	8	; ndice em bytes (dentro da ficha) do campo salrio 
null		EQU	0000H	; apontador null 

pilha	EQU	2000H		; valor inicial do SP

PLACE	1204H			; localiza ficha 1 (cabea da lista)
ficha1:
	word	1214H		; apontador para a ficha 2
	word	3029		; n mecanogrfico
	word	207		; extenso telefnica
	word	34		; idade
	word	1250		; salrio

PLACE	1214H			; localiza ficha 2
ficha2:
	word	1226H		; apontador para a ficha 3
	word	1978		; n mecanogrfico
	word	225		; extenso telefnica
	word	23		; idade
	word	990		; salrio

PLACE	1226H			; localiza ficha 3
ficha3:
	word	null		; apontador null (cauda da lista)
	word	2389		; n mecanogrfico
	word	217		; extenso telefnica
	word	47		; idade
	word	1650		; salrio

PLACE	1234H			; localiza ficha 4
ficha4:
	word	null		; apontador null (para j, pois esta ficha ainda
				; no est na lista)
	word	1027		; n mecanogrfico
	word	234		; extenso telefnica
	word	58		; idade
	word	2025		; salrio

PLACE	0000H			; localiza bloco de instrues
incio:
	MOV	SP, pilha	; inicializa SP
	MOV	R1, ficha1	; apontador para a cabea da lista
	MOV	R2, 2389	; nmero mecanogrfico do empregado 3
	CALL	Idade		; obtm idade deste empregado

	MOV	R1, ficha2	; apontador para a ficha aps a qual se vai inserir
	MOV	R2, ficha4	; apontador para a ficha a inserir
	CALL	Insere		; insere esta ficha

	MOV	R1, ficha1	; apontador para a ficha anterior  que se pretende
				; remover
	CALL	Remove	; remove a ficha 2
fim:	JMP	fim		; o programa acabou

;*******************************************************************************
; Idade  Obtm a idade de um empregado dado o seu nmero mecanogrfico
; Entradas  R1  apontador para a cabea da lista
;            R2 - nmero mecanogrfico do empregado
; Sadas  R1  apontador para a ficha do empregado com esse n mec.
;          R2  idade do empregado (0 se o empregado no existir)
;*******************************************************************************
Idade:
	PUSH	R0			; guarda registo
maisUma:
	MOV	R0, [R1+nmero]	; obtm n mecanogrfico
	CMP	R0, R2		; v se  o nmero pretendido
	JNZ	prxima		; se no, passa  prxima ficha
	MOV	R2, [R1+idade]	; obtm idade do empregado
	JMP	acaba			; j est
prxima:
	MOV	R1, [R1]		; obtm apontador para a prxima ficha
	CMP	R1, null		; ainda h prxima ficha?
	JNZ	maisUma		; se houver (no for null), continua  procura
noh:
	MOV	R2, 0			; no achou nenhum empregado com este n mec.
acaba:
	POP	R0			; repe registo
	RET

;*******************************************************************************
; Insere  Insere uma nova ficha na lista
; Entradas  R1  apontador para a ficha aps a qual se pretende inserir a nova
;            R2  apontador para a ficha a inserir
; Sadas  nenhuma
;*******************************************************************************
Insere:
	PUSH	R0		; guarda registo
	MOV	R0, [R1]	; obtm apontador para a prxima ficha
	MOV	[R2], R0	; coloca-o no apontador da ficha a inserir
	MOV	[R1], R2	; pe ficha a apontar para a nova ficha
	POP	R0		; repe registo
	RET

;*******************************************************************************
; Remove  Remove uma ficha na lista
; Entradas  R1  apontador para a ficha anterior  que se pretende remover
; Sadas  nenhuma
;*******************************************************************************
Remove:
	PUSH	R0		; guarda registo
	MOV	R0, [R1]	; obtm apontador para a prxima ficha (a que se
				; vai remover)
	MOV	R0, [R0]	; obtm apontador para a ficha a seguir quela
				; que se vai remover
	MOV	[R1], R0	; pe ficha anterior a apontar para a ficha a
				; seguir 
	POP	R0		; repe registo
	RET
